Bug 920752 - cannot open device nodes for writing on RO filesystems
Summary: cannot open device nodes for writing on RO filesystems
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel
Version: 6.4
Hardware: All
OS: Linux
high
low
Target Milestone: rc
: ---
Assignee: Eric Sandeen
QA Contact: Eryu Guan
URL:
Whiteboard:
: 923778 928026 951311 951668 955580 957780 962624 962630 (view as bug list)
Depends On:
Blocks: 832743 855142 928683 961662 CVE-2013-2188 1020725
TreeView+ depends on / blocked
 
Reported: 2013-03-12 16:28 UTC by Mateusz Guzik
Modified: 2018-12-03 18:27 UTC (History)
23 users (show)

Fixed In Version: kernel-2.6.32-375.el6
Doc Type: Bug Fix
Doc Text:
A bug in the do_filp_open() function caused it to exit early if any write access was requested on a read-only file system. This prevented the opening of device nodes on a read-only file system. With this update, the do_filp_open() has been fixed to no longer exit if a write request is made on a read-only file system.
Clone Of:
: 1020725 (view as bug list)
Environment:
Last Closed: 2013-11-21 16:56:45 UTC
Target Upstream Version:


Attachments (Terms of Use)
patch (1.93 KB, patch)
2013-03-12 16:28 UTC, Mateusz Guzik
no flags Details | Diff
the result of "sosreport -a" on NFS server (14.03 MB, application/octet-stream)
2013-05-24 21:19 UTC, IBM Bug Proxy
no flags Details
the result of "sosreport --batch" (1.03 MB, application/octet-stream)
2013-05-24 21:20 UTC, IBM Bug Proxy
no flags Details


Links
System ID Private Priority Status Summary Last Updated
Red Hat Knowledge Base (Solution) 376833 0 None None None Never
Red Hat Product Errata RHSA-2013:1645 0 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 6 kernel update 2013-11-20 22:04:18 UTC

Description Mateusz Guzik 2013-03-12 16:28:27 UTC
Created attachment 709070 [details]
patch

Description of problem:

If a filesystem is mounted read-only it is not possible to open device nodes residing on it for writing.

Version-Release number of selected component (if applicable):

kernel-2.6.32-327.el6 and up, introduced in:
1d3c71fcd66a1204fb43f3f06221732c6df1c7c2                                      
Author: Eric Sandeen <sandeen@redhat.com>
Date:   Mon Sep 24 21:27:50 2012 -0400

    [fs] Push mnt_want_write() outside of i_mutex

How reproducible:

Always

Steps to Reproduce:
1. prepare fs
dd if=/dev/zero of=foo bs=1M count=10
losetup -vf foo
mkfs.ext3 /dev/loop0
mount /dev/loop0 /mnt
mknod /mnt/null c 1 3
umount /mnt
2. mount fs ro: mount -o ro /dev/loop0 /mnt
3. Try to write: echo foo >> /mnt/null       
  
Actual results:

zsh: read-only file system: /mnt/null

Expected results:

successful open + write

Comment 2 Ric Wheeler 2013-03-12 19:42:27 UTC
This behaviour makes some sense for a read-only file system. Are you looking to make a read-only root for security reasons? Is this a real issue in production or just a feature request?

Thanks!

Comment 3 Eric Sandeen 2013-03-12 20:31:36 UTC
Ric, we do need to be able to open devices RW even if the device node is on an RO fs.  Looks like a regression from the big freeze patchset.  I'll take it.

Thanks,
-Eric

Comment 4 Mateusz Guzik 2013-03-13 12:31:54 UTC
Same customer reported broken write support for file bind mounts (mount --bind file /rofs/file). This is also fixed with attached patch.

Comment 10 Eric Sandeen 2013-03-22 21:48:30 UTC
*** Bug 923778 has been marked as a duplicate of this bug. ***

Comment 14 Eric Sandeen 2013-05-01 15:22:33 UTC
*** Bug 928026 has been marked as a duplicate of this bug. ***

Comment 15 Eric Sandeen 2013-05-01 16:56:52 UTC
*** Bug 955580 has been marked as a duplicate of this bug. ***

Comment 16 Eric Sandeen 2013-05-08 17:10:18 UTC
*** Bug 957780 has been marked as a duplicate of this bug. ***

Comment 17 Jarod Wilson 2013-05-08 20:34:12 UTC
Patch(es) available on kernel-2.6.32-375.el6

Comment 20 Eric Sandeen 2013-05-15 15:47:03 UTC
I've taken the private flag off this bug, several people have run into this, several bugs have been duped to it, and there's nothing sensitive here.

Comment 21 Eric Sandeen 2013-05-24 21:04:59 UTC
*** Bug 962624 has been marked as a duplicate of this bug. ***

Comment 22 IBM Bug Proxy 2013-05-24 21:19:47 UTC
Created attachment 752878 [details]
the result of "sosreport -a" on NFS server

Comment 23 IBM Bug Proxy 2013-05-24 21:20:03 UTC
Created attachment 752879 [details]
the result of "sosreport --batch"

Comment 24 Petr Matousek 2013-06-18 14:31:45 UTC
*** Bug 962630 has been marked as a duplicate of this bug. ***

Comment 27 Eryu Guan 2013-08-30 09:57:06 UTC
ext2/3/4 xfs and btrfs all passed xfstests generic/306 which is the reproducer for this bug.

Set to VERIFIED.

Comment 28 errata-xmlrpc 2013-11-21 16:56:45 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-1645.html

Comment 29 Mateusz Guzik 2014-05-09 04:49:36 UTC
*** Bug 951311 has been marked as a duplicate of this bug. ***

Comment 30 Eric Sandeen 2014-07-15 15:39:16 UTC
*** Bug 951668 has been marked as a duplicate of this bug. ***


Note You need to log in before you can comment on or make changes to this bug.